Subject: Re: [bitcoin-dev] Taproot proposal

From: "Russell O'Connor" <[email-masked]>
Date: Fri, 28 Jun 2019 07:16:46 -0400

Hmm? If I'm following what you mean, that's not the P2P rules, it's the
> Unserialize code, in particular:
>
>   compat/assumptions.h:52:static_assert(sizeof(int) == 4, "32-bit int
> assumed");
>
>   serialize.h:289:uint64_t ReadCompactSize(Stream& is)
>
>   serialize.h-679-template<typename Stream, unsigned int N, typename T,
> typename V>
>   serialize.h-680-void Unserialize_impl(Stream& is, prevector<N, T>& v,
> const V&)
>   serialize.h-681-{
>   serialize.h-682-    v.clear();
>   serialize.h:683:    unsigned int nSize = ReadCompactSize(is);
>
>   (and other Unserialize_impl implementations)
>
> However, ReadCompactSize throws "size too large" if the return value is
> greater than MAX_SIZE == 0x02000000 =~ 33.5M, which prior to the implicit
> cast to 32 bits in Unserialize_impl. And it looks like that check's been
> there since Satoshi...
>
> So as far as I can see, that encoding's just unsupported/invalid, rather
> than equivalent/non-canonical?
>

Thanks for this correction!  I totally missed that MAX_SIZE == 0x02000000.
I think I mistook it for SIZE_MAX when reviewing this, or just didn't
notice it at all.

Cheers,
> aj